SuperStrict
AppTitle = "BlitzPoint"
Incbin "media/fonts/fontin.ttf"
Incbin "media/images/Hintergrund.png"
SeedRnd MilliSecs()
Global ScreenWidth:Int = 800
Global ScreenHeight:Int = 600
Graphics ScreenWidth, ScreenHeight
SetBlend(ALPHABLEND)
SetMaskColor 8,32,16
Include "TGif.bmx"
Include "TElement.bmx"
Include "TPage.bmx"
Include "TFontCollection.bmx"
Include "TSpeedControl.bmx"
Include "TDynamicImageReduced.bmx"
Include "TPlainReduced.bmx"
Include "TPageChange.bmx"
Include "CreatePermutation.bmx"
Include "PixmapPaste.bmx"
Global FontCollection:TFontCollection = New TFontCollection
Global Background:TImage
Local Exportpfad:String = ""
Local PageChange:TPageChange
'---------------------------------------------------------------------
Global Page:TPage[100]
For Local i:Int = 0 To 99
	Page[i] = New TPage
Next
'---------------------------------------------------------------------
'=========================================================
Local Vollbildmodus:Byte = False
Local Hintergrunddatei:String = "incbin::media/images/Hintergrund.png"
Local Schriftart:String = "incbin::media/fonts/fontin.ttf"
Local Schriftgroesse:Int = 24
Local Farbe:Int[] = [255,255,255]
Local Dauer:Int=1000
Local Elementsound:String
Local Animationszeit:Int=500
Local Animationssound:String
Local Seitenwechselzeit:Int=500
Local Seitenwechsel:Int=0
Local Seitenwechselsound:String
Local Ausrichtung:String="Zentriert"
Local Einruecken:Int=0
'Local AnimDaten?= Breite, Hhe, Anzahl, Dauer-Array[], Sound-Pfad
Local KeineAnimDaten:Byte = True
Local Interaktion:Int
Local InteraktionsInfo:String
Local Exportieren:Byte=False
Local Animation:Int
Local Anordnung:String = "Untereinander"
Local GifAnzahl:Int
Local GifBreite:Int
Local GifHoehe:Int
Local GifMillisekunden:Int[]
Local GifSound:String
Local RGB:Int[] = [255,255,255]
'=========================================================
Local AllPageCount:Int = 0
Local P_Index:Int = 0
Local PageHeightSum:Int = 0
Local PageWidthSum:Int = 0
Local PageMaxWidth:Int = 0
Local ElementLeft:Int = 0.1*ScreenWidth
Local ElementRight:Int = 0.9*ScreenWidth
Local E_Index:Int = 0
'=========================================================
Local StartArgument:String[] = AppArgs[1..]
If StartArgument = Null Or FileType(StartArgument[0]) <> 1 Then
	StartArgument = New String[1]
	StartArgument[0] = RequestFile("Lade Prsentations-Skript", "BlitzPointScripts:bps;" , , CurrentDir())
	If StartArgument[0] = "" Then End
End If
'=========================================================
Local ScriptFileName:String = StartArgument[0]
'ScriptFileName = "/home/udo/Desktop/TestScript.bps"
'ScriptFileName = "/home/udo/Desktop/Slideshow-Script.bps"
'ScriptFileName = "/home/udo/Desktop/Flexible Seiten-Navigation.bps"
Local Line:String, Script:TStream = ReadStream(ScriptFileName)
If Script = Null Then
	Notify "Das Prsentations-Skript~n" + Chr(34) + ScriptFileName + Chr(34) + "~nkonnte nicht geladen werden!~nDas Programm wird beendet."
	End
End If
'=========================================================
While Not Eof(Script)
	'-------------------------------------------------------
	Line  = Trim(ReadLine(Script))
	'-------------------------------------------------------
	If Left(Line, 9) = "#Element="
		'-------------------------------------------------------
		If GifAnzahl <= 0 Or GifBreite <= 0 Or GifHoehe <= 0 Then  'Textzeile oder Bild
			'-------------------------------------------------------
			If Animation < 17 Then
				Page[P_Index].addElement(Right(Line, Len(Line)-9), Animation, Dauer, Animationszeit, , Animationssound, Elementsound, Interaktion, InteraktionsInfo, RGB, Schriftart, Schriftgroesse)
			Else 'zufllig
				Page[P_Index].addElement(Right(Line, Len(Line)-9), Rand(0,16), Dauer, Animationszeit, , Animationssound, Elementsound, Interaktion, InteraktionsInfo, RGB, Schriftart, Schriftgroesse)
			End If
			'-------------------------------------------------------
		Else   'If GifAnzahl > 0 And GifBreite > 0 And GifHoehe > 0 Then  'TGif
			Local Gif:TGif = TGif.build(Trim(Right(Line, Len(Line)-9)), GifBreite, GifHoehe, GifAnzahl, GifMillisekunden, GifSound)
			'-------------------------------------------------------
			If Animation < 17 Then
				Page[P_Index].addElement("", Animation, Dauer, Animationszeit, Gif, Animationssound, Elementsound, Interaktion, InteraktionsInfo, RGB)
			Else 'zufllig
				Page[P_Index].addElement("", Rand(0,16), Dauer, Animationszeit, Gif, Animationssound, Elementsound, Interaktion, InteraktionsInfo, RGB)
			End If
			'-------------------------------------------------------
		End If
		'-------------------------------------------------------
		If Anordnung <> "Nebeneinander" Then   'also Anordnung = "Untereinander"
			PageHeightSum = PageHeightSum + 2*Page[P_Index].Element[E_Index].HalfHeight
			PageMaxWidth = Max(PageMaxWidth, 2*Page[P_Index].Element[E_Index].HalfWidth)
		Else   'If Anordnung = "Nebeneinander" Then
			'- - - - fehlt noch - - - -
		End If
		'-------------------------------------------------------
		If Ausrichtung = "Zentriert" Then
			Page[P_Index].Element[E_Index].PosX = ScreenWidth/2 + Einruecken
			ElementLeft = Page[P_Index].Element[E_Index].PosX - Page[P_Index].Element[E_Index].HalfWidth
			ElementRight = Page[P_Index].Element[E_Index].PosX + Page[P_Index].Element[E_Index].HalfWidth
		ElseIf Ausrichtung = "Links" Then
			Page[P_Index].Element[E_Index].PosX = ElementLeft + Einruecken + Page[P_Index].Element[E_Index].HalfWidth
		ElseIf Ausrichtung = "Rechts" Then
			Page[P_Index].Element[E_Index].PosX = ElementRight + Einruecken - Page[P_Index].Element[E_Index].HalfWidth
		End If
		E_Index = E_Index + 1
		'-------------------------------------------------------
	ElseIf Left(Line, 11) = "#Animation=" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line) - 11))
		Select Line
			Case "Einblenden"
				Animation = 0
			Case "Zoomen-A"
				Animation = 1
			Case "Zoomen-B"
				Animation = 2
			Case "Falten"
				Animation = 3
			Case "Verschieben von Links"
				Animation = 4
			Case "Verschieben von Rechts"
				Animation = 5
			Case "Verschieben von Unten"
				Animation = 6
			Case "Verschieben von Oben"
				Animation = 7
			Case "Aufziehen von Links"
				Animation = 8
			Case "Aufziehen von Rechts"
				Animation = 9
			Case "Aufziehen von Oben"
				Animation = 10
			Case "Aufziehen von Unten"
				Animation = 11
			Case "Mosaik"
				Animation = 12
			Case "Drehen"
				Animation = 13
			Case "Zittern"
				Animation = 14
			Case "Pseudo-3D-A"
				Animation = 15
			Case "Pseudo-3D-B"
				Animation = 16
			Default   '"Zufllig"
				Animation = 17
		End Select
		'-------------------------------------------------------
	ElseIf Left(Line, 16) = "#Animationszeit=" Then
		'-------------------------------------------------------
		Animationszeit  = Int(Trim(Right(Line, Len(Line)-16)))
		'-------------------------------------------------------
	ElseIf Left(Line, 17) = "#Animationssound=" Then
		'-------------------------------------------------------
		Animationssound  = Trim(Right(Line, Len(Line)-17))
		'-------------------------------------------------------
	ElseIf Left(Line, 7) = "#Dauer=" Then
		'-------------------------------------------------------
		Dauer  = Int(Trim(Right(Line, Len(Line)-7)))
		'-------------------------------------------------------
	ElseIf Left(Line, 7) = "#Sound=" Then
		'-------------------------------------------------------
		Elementsound  = Trim(Right(Line, Len(Line)-7))
		'-------------------------------------------------------
	ElseIf Left(Line, 13) = "#Interaktion:" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line)-13))
		If Left(Line, 14) = "Gehe zu Seite=" Then
			Interaktion = 1
			InteraktionsInfo = Trim(Right(Line, Len(Line)-14))
		ElseIf Left(Line, 11) = "Zeige Info=" Then
			Interaktion = 2
			InteraktionsInfo = Right(Line, Len(Line)-11)
		ElseIf Left(Line, 11) = "Zeige Bild=" Then
			Interaktion = 3
			InteraktionsInfo = Right(Line, Len(Line)-11)
		ElseIf Left(Line, 13) = "Spiele Sound=" Then
			Interaktion = 4
			InteraktionsInfo = Right(Line, Len(Line)-13)
		ElseIf Left(Line, 14) = "Starte Skript=" Then
			Interaktion = 5
			InteraktionsInfo = Right(Line, Len(Line)-14)
		ElseIf Left(Line, 10) = "ffne URL=" Then
			Interaktion = 6
			InteraktionsInfo = Right(Line, Len(Line)-10)
		ElseIf Left(Line, 5) = "Ende" Then
			Interaktion = 7
		Else '
			Interaktion = 0
		End If
		'-------------------------------------------------------
	ElseIf Left(Line, 13) = "#Ausrichtung=" Then
		'-------------------------------------------------------
		Ausrichtung = Trim(Right(Line, Len(Line)-13))
		'-------------------------------------------------------
	ElseIf Left(Line, 11) = "#Anordnung=" Then
		'-------------------------------------------------------
		Anordnung = Trim(Right(Line, Len(Line)-11))
		'-------------------------------------------------------
	ElseIf Left(Line, 11) = "#Einrcken=" Then
		'-------------------------------------------------------
		Einruecken  = Int(Trim(Right(Line, Len(Line)-11)))
		'-------------------------------------------------------
	ElseIf Left(Line, 18) = "#Hintergrunddatei=" Then
		'-------------------------------------------------------
		Hintergrunddatei = Trim(Right(Line, Len(Line)-18))
		'-------------------------------------------------------
	ElseIf Left(Line, 9) = "#Vollbild" Then
		'-------------------------------------------------------
		VollbildModus = True

		'? ? ?

		'-------------------------------------------------------
	ElseIf Left(Line, 12) = "#Bildschirm=" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line)-12))
		Local xPosition:Int = Instr(Line,"x")
		If xPosition > 0 Then
			Local NewScreenWidth:Int = Int(Trim(Left(Line, xPosition-1)))
			Local NewScreenHeight:Int = Int(Trim(Right(Line, Len(Line)-xPosition)))
			If NewScreenWidth <> ScreenWidth Or NewScreenHeight <> ScreenWidth Then
				ScreenWidth = NewScreenWidth
				ScreenHeight = NewScreenHeight
				Graphics ScreenWidth, ScreenHeight, VollbildModus*32
				SetBlend ALPHABLEND
				ElementLeft = 0.1*ScreenWidth
				ElementRight = 0.9*ScreenWidth
			End If
		End If
		'-------------------------------------------------------
	ElseIf Left(Line, 7) = "#Farbe=" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line)-7))
		Select Line
			Case "Wei"
				RGB = [255, 255, 255]
			Case "Hellgrau"
				RGB = [192, 192, 192]
			Case "Grau"
				RGB = [127, 127, 127]
			Case "Dunkelgrau"
				RGB = [64, 64, 64]
			Case "Schwarz"
				RGB = [0, 0, 0]
			Case "Hellrot"
				RGB = [255, 127, 127]
			Case "Rot"
				RGB = [255, 0, 0]
			Case "Dunkelrot"
				RGB = [127, 0, 0]
			Case "Hellgrn"
				RGB = [127, 255, 127]
			Case "Grn"
				RGB = [0, 255, 0]
			Case "Dunkelgrn"
				RGB = [0, 127, 0]
			Case "Hellblau"
				RGB = [127, 127, 255]
			Case "Blau"
				RGB = [0, 0, 255]
			Case "Dunkelblau"
				RGB = [0, 0, 127]
			Case "Hellgelb"
				RGB = [255, 255, 127]
			Case "Gelb"
				RGB = [255, 255, 0]
			Case "Dunkelgelb"
				RGB = [127, 127, 0]
			Case "Helltrkis"
				RGB = [127, 255, 255]
			Case "Trkis"
				RGB = [0, 255, 255]
			Case "Dunkeltrkis"
				RGB = [0, 127, 127]
			Case "Hellviolett"
				RGB = [255, 127, 255]
			Case "Violett"
				RGB = [255, 0, 255]
			Case "Dunkelviolett"
				RGB = [127, 0, 127]
			Case "Hellorange"
				RGB = [255, 192, 127]
			Case "Orange"
				RGB = [255, 127, 0]
			Case "Hellbraun"
				RGB = [200, 100, 50]
			Case "Braun"
				RGB = [127, 64, 0]
		End Select
		'-------------------------------------------------------
	ElseIf Left(Line, 12) = "#Schriftart=" Then
		'-------------------------------------------------------
		Schriftart = Trim(Right(Line, Len(Line)-12))
		'-------------------------------------------------------
	ElseIf Left(Line, 14) = "#Schriftgre=" Then
		'-------------------------------------------------------
		Schriftgroesse = Int(Trim(Right(Line, Len(Line)-14)))
		'-------------------------------------------------------
	ElseIf Left(Line, 12) = "#Gif-Anzahl=" Then
		'-------------------------------------------------------
		GifAnzahl = Int(Trim(Right(Line, Len(Line)-12)))
		'-------------------------------------------------------
	ElseIf Left(Line, 12) = "#Gif-Breite=" Then
		'-------------------------------------------------------
		GifBreite = Int(Trim(Right(Line, Len(Line)-12)))
		'-------------------------------------------------------
	ElseIf Left(Line, 10) = "#Gif-Hhe=" Then
		'-------------------------------------------------------
		GifHoehe = Int(Trim(Right(Line, Len(Line)-10)))
		'-------------------------------------------------------
	ElseIf Left(Line, 19) = "#Gif-Millisekunden=" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line)-19))
		Local i:Int, j:Int, k:Int, ArrayLen:Int = 1
		While j < Len(Line)
			j = j + 1
			If Mid(Line, j, 1) = "," Then ArrayLen = ArrayLen + 1
		Wend
		GifMillisekunden = New Int[ArrayLen]
		i = 1
		j = 0
		k = 0
		While j < Len(Line)
			j = j + 1
			If Mid(Line, j, 1) = "," Then
				GifMillisekunden[k] = Int(Trim(Mid(Line, i, j-i)))
				i = j + 1
				k = k + 1
			End If
		Wend
		GifMillisekunden[k] = Int(Trim(Right(Line, Len(Line)-i+1)))
		'-------------------------------------------------------
	ElseIf Left(Line, 11) = "#Gif-Sound=" Then
		'-------------------------------------------------------
		GifSound = Trim(Right(Line, Len(Line)-11))
		'-------------------------------------------------------
	ElseIf Left(Line, 19) = "#Seitenwechselzeit=" Then
		'-------------------------------------------------------
		Seitenwechselzeit =  Int(Trim(Right(Line, Len(Line)-19)))
		'-------------------------------------------------------
	ElseIf Left(Line, 20) = "#Seitenwechselsound=" Then
		'-------------------------------------------------------
		Seitenwechselsound = Trim(Right(Line, Len(Line)-20))
		'-------------------------------------------------------
	ElseIf Left(Line, 15)= "#Seitenwechsel=" Then
		'-------------------------------------------------------
		Line = Trim(Right(Line, Len(Line)-15))
		Select Line
			Case "berblenden"
				Seitenwechsel = 0
			Case "Spotlight"
				Seitenwechsel = 1
			Case "Drehscheibe abwrts"
				Seitenwechsel = 2
			Case "Drehscheibe aufwrts"
				Seitenwechsel = 3
			Case "Schleuse"
				Seitenwechsel = 4
			Case "Verschieben nach Links"
				Seitenwechsel = 5
			Case "Verschieben nach Rechts"
				Seitenwechsel = 6
			Case "Verschieben und Zoomen nach Links"
				Seitenwechsel = 7
			Case "Verschieben und Zoomen nach Rechts"
				Seitenwechsel = 8
			Case "Abblttern"
				Seitenwechsel = 9
			Case "Aufblttern"
				Seitenwechsel = 10
			Case "Kacheln zoomen"
				Seitenwechsel = 11
			Case "Kacheln blitzen"
				Seitenwechsel = 12
			Case "Kacheln rotieren von Rechts"
				Seitenwechsel = 13
			Case "Kacheln rotieren von Oben"
				Seitenwechsel = 14
			Case "Kachelpermutation"
				Seitenwechsel = 15
			Case "Kacheln verdrehen"
				Seitenwechsel = 16
			Case "Kacheln fallen"
				Seitenwechsel = 17
			Case "Kippen"
				Seitenwechsel = 18
			Case "3D-Seite-A"
				Seitenwechsel = 19
			Case "3D-Seite-B"
				Seitenwechsel = 20
			Case "3D-Blatt-A"
				Seitenwechsel = 21
			Case "3D-Blatt-B"
				Seitenwechsel = 22
			Case "3D-Tren-A"
				Seitenwechsel = 23
			Case "3D-Tren-B"
				Seitenwechsel = 24
			Case "3D-Tren-C"
				Seitenwechsel = 25
			Case "3D-Tren-D"
				Seitenwechsel = 26
			Case "3D-Quader dreht nach Unten"
				Seitenwechsel = 27
			Case "3D-Quader dreht nach Oben"
				Seitenwechsel = 28
			Case "3D-Quader dreht nach Rechts"
				Seitenwechsel = 31
			Case "3D-Quader dreht nach Links"
				Seitenwechsel = 32
			Case "3D-Ecke dreht nach Unten"
				Seitenwechsel = 29
			Case "3D-Ecke dreht nach Oben"
				Seitenwechsel = 30
			Case "3D-Ecke dreht nach Rechts"
				Seitenwechsel = 33
			Case "3D-Ecke dreht nach Links"
				Seitenwechsel = 34
			Case "Zufall-Einfach" 'nur die simpelsten: 0 bis 4
				Seitenwechsel = 35
			Case "Zufall-Verschieben"  'verschieben: 5 bis 8
				Seitenwechsel = 36
			Case "Zufall-Kacheln" 'alle Kacheln/Mosaik: 11 bis 17
				Seitenwechsel = 37
			Case "Zufall-2D" 'Alles auer 3D: 0 bis 17
				Seitenwechsel = 38
			Case "Zufall-3D" 'nur 3D: 18 bis 34
				Seitenwechsel = 39
			Case "Zufall-Spezial" 'eine Auswahl meiner persnlichen Favoriten
				Seitenwechsel = 40
			Default   'Total zufllig
				Seitenwechsel = 41
		End Select
		'-------------------------------------------------------
	ElseIf Left(Line, 14)= "#Nchste Seite" Or Left(Line, 15) = "#Gehe zu Seite=" Or Left(Line, 5) = "#Ende" Then
		'-------------------------------------------------------
		Page[P_Index].Seitenwechselzeit = Seitenwechselzeit
		Page[P_Index].Seitenwechselsound=Seitenwechselsound
		Page[P_Index].Seitenwechsel = Seitenwechsel
		'-------------------------------------------------------
		If Page[P_Index].Count > 0 Then
			Local Zwischenraum:Int = (ScreenHeight - PageHeightSum) / (Page[P_Index].Count+3)
			Page[P_Index].Element[0].PosY = 2*Zwischenraum + Page[P_Index].Element[0].HalfHeight
			For Local i:Int = 1 To Page[P_Index].Count-1
				Page[P_Index].Element[i].PosY = Page[P_Index].Element[i-1].PosY  + Page[P_Index].Element[i-1].HalfHeight + Zwischenraum + Page[P_Index].Element[i].HalfHeight
			Next
		End If
		'-------------------------------------------------------
		PageHeightSum = 0
		PageWidthSum = 0
		PageMaxWidth = 0
		ElementLeft= 0.1*ScreenWidth
		ElementRight = 0.9*ScreenWidth
		E_Index = 0
		If Left(Line, 14)= "#Nchste Seite" Then
			Page[P_Index].AfterShowGotoPage = P_Index + 1
		ElseIf Left(Line, 15) = "#Gehe zu Seite=" Then
			Page[P_Index].AfterShowGotoPage = Int(Trim(Right(Line, Len(Line)-15)))-1
		Else   'Left(Line, 5) = "#Ende"
			Page[P_Index].AfterShowGotoPage = 16777216  '= 2^24 (in der sicheren Erwartung, dies ist > AllPageCount)
		End If
		P_Index = P_Index + 1
		'-------------------------------------------------------
	ElseIf Left(Line, 8)= "#Export=" Then
		'-------------------------------------------------------
		Exportpfad = Trim(Right(Line, Len(Line)-8))
		Exportieren = True
		'-------------------------------------------------------
	End If
Wend
'-------------------------------------------------------
If Left(Line, 15) <> "#Seitenwechsel=" And Page[P_Index].Count > 0 Then
	Local Zwischenraum:Int = (ScreenHeight - PageHeightSum) / (Page[P_Index].Count+1)
	Page[P_Index].Element[0].PosY = Zwischenraum + Page[P_Index].Element[0].HalfHeight
	For Local i:Int = 1 To Page[P_Index].Count-1
		Page[P_Index].Element[i].PosY = Page[P_Index].Element[i-1].PosY  + Page[P_Index].Element[i-1].HalfHeight + Zwischenraum + Page[P_Index].Element[i].HalfHeight
	Next
End If

AllPageCount = P_Index    '+ 1 '(Fehler?)
'??? Hier fehlen noch einige Notbremsen Was ist, wenn gar nichts drin ist?

CloseStream(Script)
'=========================================================
'#########################################################
'=========================================================
Background = LoadImage(Hintergrunddatei)
If Background = Null Then   'Notanker bei Ladeproblemen oder bewusst 'Hintergrunddatei = ""
	Cls
	Background = LoadImage(GrabPixmap(0,0,ScreenWidth,ScreenHeight))
End If
P_Index = 0
'=========================================================
'#########################################################
'=========================================================
If Exportieren = False Then   'kein Export, sondern Vorfhrung!
	Local InterAktionsReturn:String
	Repeat
		Local Old_P_Index:Int = P_Index
		InterAktionsReturn = Page[P_Index].show()
		If InterAktionsReturn <> "" Then
			Page[P_Index].Index = 0
			P_Index = Int(InterAktionsReturn) - 1   'Die Skripte zhlen von 1 ab, NICHT von Null
		Else
			Page[P_Index].Index = 0  '(quasi Zurcksetzen)
			P_Index = Max(0, Page[P_Index].AfterShowGotoPage)
		End If
		'----------------------------------------------------------------
		If P_Index < AllPageCount Then 'animierter Seitenwechsel
			SetHandle 0, 0
			SetAlpha 1.0
			SetScale 1.0, 1.0
			SetColor 255,255,255
			SetRotation 0
			Local OldPagePM:TPixmap = GrabPixmap(0,0,ScreenWidth, ScreenHeight)
			DrawImage Background, 0, 0
			Local j:Int = 0
			While j < Page[P_Index].Count And Page[P_Index].Element[j].AnimationTime = 0 And Page[P_Index].Element[j].DelayTime = 0
				Page[P_Index].Element[j].draw(Page[P_Index].Element[j].PosX, Page[P_Index].Element[j].PosY)
				j = j + 1
			Wend
			If Page[P_Index].Element[j].AnimationTime = 0 Then Page[P_Index].Element[j].draw(Page[P_Index].Element[j].PosX, Page[P_Index].Element[j].PosY)
			SetHandle 0, 0
			If Page[Old_P_Index].Seitenwechsel < 35 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Page[Old_P_Index].Seitenwechsel, 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 35 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(0,4), 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 36 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(5,8), 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 37 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(11,17), 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 38 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(0,17), 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 39 Then
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(18,34), 2, Page[Old_P_Index].Seitenwechselsound)
			ElseIf Page[Old_P_Index].Seitenwechsel = 40 Then
				Local Spezialmischung:Int[] = [5, 13, 15, 16, 17, 19, 22, 25, 26, 27]
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Spezialmischung[Rand(0,9)], 2, Page[Old_P_Index].Seitenwechselsound)
			Else 'Page[Old_P_Index].Seitenwechsel = 41 Then   '(total zufllig)
				PageChange = TPageChange.build(OldPagePM, GrabPixmap(0,0,ScreenWidth, ScreenHeight), Rand(0,34), 2, Page[Old_P_Index].Seitenwechselsound)
			End If
			DrawPixmap(OldPagePM, 0, 0)
			While PageChange.show(Page[Old_P_Index].Seitenwechselzeit) = False 'and (Benutzerinput?)  '2000??? Page[Old_P_Index].Seitenwechselzeit?
				Flip
			Wend
		End If
		'----------------------------------------------------------------
	Until P_Index >= AllPageCount Or KeyDown(KEY_ESCAPE) Or AppTerminate() = True
	'---------------------------------------------------------------------
'=========================================================
Else  'If Exportieren = True Then   'Keine Vorfhrung, nur Bildexport der Seiten!
	SetHandle 0, 0
	SetAlpha 1.0
	SetScale 1.0, 1.0
	SetColor 255,255,255
	SetRotation 0
	FontCollection.set("incbin::media/fonts/fontin.ttf", 28)
	Local Info:String = "Bitte warten!"
	DrawText Info, (ScreenWidth-TextWidth(Info))/2, ScreenHeight/2-2*TextHeight(Info)
	Info = "Alle Seiten werden exportiert ..."
	DrawText Info, (ScreenWidth-TextWidth(Info))/2, ScreenHeight/2+TextHeight(Info)
	Flip
	Local Stellenanzahl:Int = Len(String(AllPageCount))
	While P_Index < AllPageCount
		Local DateiNr:String = String(P_Index+1)
		While Len(DateiNr) < Stellenanzahl
			DateiNr = "0" + DateiNr
		Wend
		DrawImage Background, 0, 0
		For E_Index = 0 To Page[P_Index].Count-1
			Page[P_Index].Element[E_Index].draw(Page[P_Index].Element[E_Index].PosX, Page[P_Index].Element[E_Index].PosY)
		Next
		SavePixmapPNG(GrabPixmap(0,0,ScreenWidth, ScreenHeight), Exportpfad + "_Seite-" + DateiNr + ".png")
		P_Index = P_Index+1
	Wend
	Cls
	FontCollection.set("incbin::media/fonts/fontin.ttf", 28)
	Info = "Export abgeschlossen!"
	SetHandle 0, 0
	DrawText Info, (ScreenWidth-TextWidth(Info))/2, ScreenHeight/2-TextHeight(Info)/2
	Flip
	Delay 1000
End If
'=========================================================