'#################################
Type TGif
'#################################
	Field Image:TImage, Width:Int, Height:Int, Count:Int, Wait:Int[], Sound:TSound, Frame:Int, Time:Int
	'===============================
	Function build:TGif(Imagepath:String, NewWidth:Int, NewHeight:Int, NewCount:Int, NewWait:Int[] = Null, Soundpath:String = "")
		Local NTG:TGif = New TGif
		NTG.Width = NewWidth
		NTG.Height = NewHeight
		NTG.Count = NewCount
		NTG.Image = LoadAnimImage(Imagepath, NewWidth, NewHeight, 0, NewCount)
		MidHandleImage(NTG.Image)
		NTG.Wait = New Int[NewCount]
		Local w:Int, i:Int, L:Int = Len(NewWait)
		While i < L
			w = NewWait[i]
			NTG.Wait[i] = w
			i = i + 1
		Wend
		While i < NewCount
			NTG.Wait[i] = w
			i = i + 1
		Wend
		If Soundpath <> "" Then NTG.Sound = LoadSound(Soundpath)
		NTG.Frame = NewCount-1
		NTG.Time = MilliSecs()
		Return NTG
	'===============================
	End Function   'build()
	'===============================
	Method draw(X:Float, Y:Float)
	'===============================
		If MilliSecs()-Time > Wait[Frame] Then
			Frame = Frame + 1
			If Frame = Count Then
				Frame = 0
				If Sound <> Null Then PlaySound(Sound)
			End If
			Time = MilliSecs()
		End If
		DrawImage Image, X, Y, Frame
	'===============================
	End Method   'draw()
	'===============================
'#################################
End Type   'TGif
'#################################