'#############################################################################
Function CreatePermutation:Int[](Count:Int, TendenzExponent:Float = 1.0)
'#############################################################################
	If Count <= 0 Then Return [0]
	Local i:Int, j:Int, MemNumber:Int
	Local Result:Int[Count]
	Count = Count - 1
	For i = 0 To Count
		Result[i] = i
	Next
	For i = Count To 1 Step -1
		Local Random:Int = (i+1)*(Rnd())^TendenzExponent
		MemNumber = Result[i]
		Result[i] = Result[Random]
		If Random < i Then
			For j = Random To i - 1
				Result[j] = Result[j + 1]
			Next
			Result[i - 1] = MemNumber
		End If
	Next
	Return Result
End Function