'########################################################################
Function PixmapPaste(PMZ:TPixmap, PMQ:TPixmap, x:Int, y:Int, Quell_Alpha:Float = 1)
'########################################################################
	If Quell_Alpha <> 1 Then Quell_Alpha = Min(1, Max(0, Quell_Alpha))
	Local Breite_Z:Int = PixmapWidth(PMZ), Tiefe_Z:Int = PixmapHeight(PMZ)
	Local Breite_Q:Int = PixmapWidth(PMQ), Tiefe_Q:Int = PixmapHeight(PMQ)
	'Komplett daneben?:
	If x >= Breite_Z Or x+Breite_Q <= 0 Or y >= Tiefe_Z Or y+Tiefe_Q <= 0 Then Return
	'Alle Rnder abchecken:
	Local x_Start_Z:Int = Max(0,x),   x_Start_Q:Int = Max(0,-x)
	Local x_End_Q:Int = Breite_Q - 1
	If x + Breite_Q > Breite_Z Then x_End_Q = Breite_Z - x - 1
	Local y_Start_Z:Int = Max(0,y),   y_Start_Q:Int = Max(0,-y)
	Local y_End_Q:Int = Tiefe_Q - 1
	If y + Tiefe_Q > Tiefe_Z Then y_End_Q = Tiefe_Z - y - 1
	Local A_Q:Int, R_Q:Int, G_Q:Int, B_Q:Int, A_Z:Int, R_Z:Int, G_Z:Int, B_Z:Int
	Local ARGB_Q:Int, ARGB_Z:Int, xq:Int, yq:Int, xz:Int = x_Start_Z, yz:Int
	'----------------------------------------
	For xq = x_Start_Q To x_End_Q  'den ntigen Bereich durchlaufen
		yz = y_Start_z
		For yq = y_Start_Q To y_End_Q
			ARGB_Q = ReadPixel(PMQ, xq, yq) 'Farbe Quell-Pixmap
			A_Q = Byte((ARGB_Q & $FF000000) / $1000000)
			A_Q = Quell_Alpha * A_Q
			R_Q = Byte((ARGB_Q & $00FF0000) / $10000)
			G_Q = Byte((ARGB_Q & $0000FF00) / $100)
			B_Q = Byte(ARGB_Q & $000000FF)
			ARGB_Z = ReadPixel(PMZ, xz, yz) 'Farbe Ziel-Pixmap
			A_Z = Byte((ARGB_Z & $FF000000) / $1000000)
			R_Z = Byte((ARGB_Z & $00FF0000) / $10000)
			G_Z = Byte((ARGB_Z & $0000FF00) / $100)
			B_Z = Byte(ARGB_Z & $000000FF)
			'- - - - - - - - - - - - - - - - Mischen:
			A_Z = A_Q + (255-A_Q) * A_Z / 255
			R_Z = A_Q * R_Q / 255 + (255 - A_Q) * R_Z / 255
			G_Z = A_Q * G_Q / 255 + (255 - A_Q) * G_Z / 255
			B_Z = A_Q * B_Q / 255 + (255 - A_Q) * B_Z / 255
			ARGB_Z = A_Z*$1000000+R_Z*$10000+G_Z*$100+B_Z
			WritePixel(PMZ, xz, yz, ARGB_Z)
			'-------------------------------
			yz = yz + 1
		Next
		xz = xz + 1
	Next
End Function

