Rem
	Thasm
	Thasm is an interpreter for a language called the same.
	You can read the tutorial in the file "Thasm.htm".
	
	Copyright(c) 2009 Thunder
	
	This Program is free software; you can redistribute it And/Or modify it under the terms
	of the GNU General Public License as published by the Free Software Foundation; either
	version 3 of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
	without even the implied warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.
	See the GNU General Public License For more details.

	You should have received a copy of the GNU General Public License along with this program;
	If Not, see <http://www.gnu.org/licenses/>.
EndRem

SuperStrict
Framework brl.blitz
Import brl.retro
Import brl.filesystem
Import brl.glmax2d
Import brl.max2d
Import brl.Graphics
Import brl.linkedlist
Import brl.polledinput
Import brl.timer
Import brl.random

Global CompileTime%=MilliSecs()

SeedRnd MilliSecs()
Const THASMVERSION$="0.79 Gamma"
Local waited:Byte=0
Local datei:TStream,k%
Local file$=GetCommandLine(),kommentar:Byte=0
Local timer:TTimer=CreateTimer(60)
If Trim(file$)="-v" Or Trim(file$)="" Then Print "THASM version: "+THASMVERSION;Print;WaitKey;End
If FileType(file)<>1 Then End
datei=ReadFile(file)
If Not datei Then End
Local i%,lin$,j%,section$
Global MAXLINES%,stack:TStack=Null,stacklist:TList=CreateList()
Repeat
	lin=Trim(ReadLine(datei))
	If Instr(lin,"'") Then
		lin=Replace(lin,"\'",Chr(127))
		If Instr(lin,"'") Then
			lin=Left(lin,Instr(lin,"'")-1)
		EndIf
		lin=Replace(lin,"\'","'")
	EndIf
	If Left(lin,1)="." Then section=Trim(lin)
	If section=".text" Then
		MAXLINES:+1
	EndIf
Until Eof(datei)
Global line:String[MAXLINES,3]
Global varlist:TList=CreateList(),zahl%,s$
Global vari:TVariable
vari=New TVariable
vari.name="ax"
vari.typ=3
varlist.AddLast(vari)
vari=New TVariable
vari.name="bx"
vari.typ=3
varlist.AddLast(vari)
vari=New TVariable
vari.name="cx"
vari.typ=1
varlist.AddLast(vari)
vari=New TVariable
vari.name="dx"
vari.typ=2
varlist.AddLast(vari)
vari=New TVariable
vari.name="cmd"
vari.typ=2
varlist.AddLast(vari)
vari=New TVariable
vari.name="kbd"
vari.typ=1
varlist.AddLast(vari)
Local CallPoint:Int[400],CurrentCallPoint:Int=-1
datei.Seek(0)
i=0

For i=0 To MAXLINES-1
	lin=Trim(ReadLine(datei))
	If Instr(lin,"'") Then
		lin=Replace(lin,"\'",Chr(127))
		If Instr(lin,"'") Then
			lin=Left(lin,Instr(lin,"'")-1)
		EndIf
		lin=Trim(Replace(lin,"\'","'"))
	EndIf
	If Left(lin,2)="/'" Then kommentar=1
	If Left(lin,2)="'/" Then kommentar=0
	If kommentar=0 Then
		If Left(lin,1)="." Then section=Trim(lin)
		j=Instr(lin," ")
		
		line[i,0]=Trim(Left(lin,j-1))
		If line[i,0]="wait" Then waited=1
		If Not j Then line[i,0]=Trim(lin)
		If Instr(lin,",") And j Then
			line[i,1]=Trim(Mid(lin,j+1,Instr(lin,",")-1-j))
			line[i,2]=Trim(Mid(lin,Instr(lin,",")+1,-1))
		ElseIf Instr(lin," ",j+1) And j And section=".data" Then
			line[i,1]=Trim(Mid(lin,j+1,Instr(lin," ",j+1)-1-j))
			line[i,2]=Trim(Mid(lin,Instr(lin," ",j+1)+1,-1))
		
		ElseIf j Then
			line[i,1]=Trim(Mid(lin,j+1,-1))
			line[i,2]=""
		EndIf
		If section=".data" Then
			If Not Instr(line[i,0],"[") Then
				If line[i,1]="int" Then
					vari=New TVariable
					vari.name=line[i,0]
					vari.typ=1
					vari.wert1=Int(line[i,2])
					varlist.AddLast(vari)
				ElseIf line[i,1]="string" Then
					vari=New TVariable
					vari.name=line[i,0]
					vari.typ=2
					vari.wert2=Replace(line[i,2],Chr(34),"")
					varlist.AddLast(vari)
				ElseIf line[i,1]="single" Then
					vari=New TVariable
					vari.name=line[i,0]
					vari.typ=3
					vari.wert3=Float(line[i,2])
					varlist.AddLast(vari)
				EndIf
			Else
				k=Instr(line[i,0],"[")
				zahl=k
				k=Int(Mid(line[i,0],k+1,Instr(line[i,0],"]")-k-1))
				If line[i,1]="int" Then
					For j=0 To k
						vari=New TVariable
						vari.name=Left(line[i,0],zahl-1)+"["+String(j)+"]"
						vari.typ=1
						vari.wert1=Int(line[i,2])
						varlist.AddLast(vari)
					Next
				ElseIf line[i,1]="string" Then
					For j=0 To k
						vari=New TVariable
						vari.name=Left(line[i,0],zahl-1)+"["+String(j)+"]"
						vari.typ=2
						vari.wert1=Int(line[i,2])
						varlist.AddLast(vari)
					Next
				ElseIf line[i,1]="single" Then
					For j=0 To k
						vari=New TVariable
						vari.name=Left(line[i,0],zahl-1)+"["+String(j)+"]"
						vari.typ=3
						vari.wert1=Int(line[i,2])
						varlist.AddLast(vari)
					Next
				EndIf			
			EndIf
		EndIf
	EndIf
	If section<>".text" Then i:-1
Next
CloseFile datei
Local val1%,val2%
Local comparison:Int 'WICHTIGE VARIABLE ----------------
RepConsts()
j=GotoLabel("main",0)

Local START_WERT%=j,org1%,org2%
Global lin1$,lin2$,lin3$
For i=START_WERT To MAXLINES-1
	'Print lin1+" "+lin2+" | "+lin3
	lin1=line[i,0]
	lin2=line[i,1]
	lin3=line[i,2]
	lin2=ShRepVar(lin2)
	lin3=ShRepVar(lin3)
	RepRuntimeConsts()
	If lin1="mov" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=2 Then
					lin3=vari.wert2
				Else
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=Int(lin3)
				ElseIf vari.typ=2 Then
					If Left(lin3,1)=Chr(34) And Right(lin3,1)=Chr(34) Then
						vari.wert2=Mid(lin3,2,Len(lin3)-2)
					Else
						vari.wert2=lin3
					EndIf
				Else
					vari.wert3=Float(lin3)
				EndIf
			EndIf
		Next
	ElseIf lin1="app" Then
		AppTitle=Replace(RepVar(lin2),Chr(34),"")
	ElseIf lin1="add" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=2 Then
					lin3=vari.wert2
				Else
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1:+Int(lin3)
				ElseIf vari.typ=2 Then
					If Left(lin3,1)=Chr(34) And Right(lin3,1)=Chr(34) Then
						vari.wert2:+Mid(lin3,2,Len(lin3)-2)
					Else
						vari.wert2:+lin3
					EndIf
				Else	
					vari.wert3:+Float(lin3)
				EndIf
			EndIf
		Next
	ElseIf lin1="sub" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1:-Int(lin3)
				ElseIf vari.typ=3
					vari.wert3:-Float(lin3)
				EndIf
			EndIf
		Next
	ElseIf lin1="mul" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next		
		
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert3=Float(lin3)*(vari.wert1)
				ElseIf vari.typ=3 Then
					vari.wert3=Float(lin3)*(vari.wert3)
				EndIf
			EndIf
		Next


	ElseIf lin1="div" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next		
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=vari.wert1/Float(lin3)
				ElseIf vari.typ=3 Then
					vari.wert3=vari.wert1/Int(lin3)
				EndIf
			EndIf
		Next
	ElseIf lin1="cos" Then
		For vari=EachIn varlist
			If vari.name=lin2 And vari.typ=3 Then vari.wert3=Float(Cos(vari.wert3));Exit
		Next		
	ElseIf lin1="sin" Then
		For vari=EachIn varlist
			If vari.name=lin2 And vari.typ=3 Then vari.wert3=Float(Sin(vari.wert3));Exit
		Next		
	ElseIf lin1="inc" Then
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1:+1
				ElseIf vari.typ=3
					vari.wert3:+1
				EndIf
			EndIf
		Next
	ElseIf lin1="dec" Then
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1:-1
				ElseIf vari.typ=3
					vari.wert3:-1
				EndIf
			EndIf
		Next
	ElseIf (lin1="ce" Or lin1="cz") And comparison=0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf (lin1="cne" Or lin1="cnz") And comparison<>0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="cg" And comparison<0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="cge" And comparison<=0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="cl" And comparison>0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="cle" And comparison>=0 Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue	
	ElseIf lin1="jmp" Then
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="jz" Or lin1="je" Then
		If comparison=0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf
	ElseIf lin1="jnz" Or lin1="jne" Then
		If comparison<>0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf
	ElseIf lin1="jl" Then
		If comparison>0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf
	ElseIf lin1="jle" Then
		If comparison=>0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf
	ElseIf lin1="jg" Then
		If comparison<0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf
	ElseIf lin1="jge" Then
		If comparison<=0 Then
			i=GotoLabel(lin2,i)
			Continue
		EndIf		
	ElseIf lin1="neg" Then
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=-vari.wert1
				ElseIf vari.typ=3 Then
					vari.wert3=-vari.wert3
				EndIf
			EndIf
		Next
	ElseIf lin1="not" Then
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=Not vari.wert1
				ElseIf vari.typ=3 Then
					vari.wert3=Not vari.wert3
				EndIf
			EndIf
		Next

	ElseIf lin1="jcxz" Then
		For vari=EachIn varlist
			If vari.name="cx" Then
				If vari.wert1=0 Then i=GotoLabel(lin2,i)
				Exit
			EndIf
		Next
		Continue		
	ElseIf lin1="and" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert1)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=Int(lin3) And vari.wert1
				ElseIf vari.typ=3 Then
					vari.wert3=Int(lin3) And vari.wert3
				EndIf
			EndIf
		Next
	ElseIf lin1="or" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert1)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=Int(lin3) Or vari.wert1
				ElseIf vari.typ=3 Then
					vari.wert3=Int(lin3) Or vari.wert3
				EndIf
			EndIf
		Next
	ElseIf lin1="xor" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert1)
				EndIf
			EndIf
		Next
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					vari.wert1=(Int(lin3) Or vari.wert1)-(Int(lin) And vari.wert1)
				ElseIf vari.typ=3 Then
					vari.wert3=(Int(lin3) Or vari.wert3)-(Int(lin) And vari.wert3)
				EndIf
			EndIf
		Next
	ElseIf lin1="gfx" Then
		Graphics Int(lin2),Int(lin3),0,0
	ElseIf lin1="org" Then
		org1=Int(RepVar(lin2))
		org2=Int(RepVar(lin3))
	ElseIf lin1="cls" Then
		Cls
	ElseIf lin1="flip" Then
		Flip 1-waited
	ElseIf lin1="wait" Then
		WaitTimer timer
	ElseIf lin1="dot" Then
		Plot Int(RepVar(lin2)),Int(RepVar(lin3))
	ElseIf lin1="rect" Then
		DrawRect org1,org2,Int(RepVar(lin2)),Int(RepVar(lin3))
	ElseIf lin1="oval" Then
		DrawOval org1,org2,Int(RepVar(lin2)),Int(RepVar(lin3))
	ElseIf lin1="text" Then
		DrawText RepVar(lin2),org1,org2
	ElseIf lin1="rnd" Then
		For vari=EachIn varlist
			If vari.name=lin3 Then
				If vari.typ=1 Then
					lin3=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin3=String(vari.wert3)
				EndIf
			EndIf
		Next
		val1=Int(lin3)
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					lin2=String(vari.wert1)
				ElseIf vari.typ=3 Then
					lin2=String(vari.wert3)
				EndIf
			EndIf
		Next
		val2=Int(lin2)
		vari=TVariable(varlist.First())
		vari.wert3=Rand(val1,val2)
	ElseIf lin1="cmp" Then
		j=0
		For vari=EachIn varlist
			If vari.name=lin2 Then
				If vari.typ=1 Then
					lin2=String(vari.wert1)
				ElseIf vari.typ=2 Then
					lin2=vari.wert2
					j:+1
				ElseIf vari.typ=3 Then
					lin2=String(vari.wert3)
				EndIf
			EndIf
		Next
		If Instr(lin3,Chr(34))=0 Then
			For vari=EachIn varlist
				If vari.name=lin3 Then
					If vari.typ=1 Then
						lin3=String(vari.wert1)
					ElseIf vari.typ=2 Then
						lin3=vari.wert2
						j:+1
					ElseIf vari.typ=3 Then
						lin3=String(vari.wert3)
					EndIf
				EndIf
			Next
		Else
			lin3=Replace(lin3,Chr(34),"")
			j=2
		EndIf
		If j=1 Then RuntimeError "DEBUG >> Abfrage ungueltig! LINE: "+i;Delay 1500;End
		If j=0 Then
			comparison=Int(lin2)-Int(lin3)
		Else
			If lin2=lin3 Then
				comparison=0
			Else
				comparison=1
			EndIf
		EndIf
	ElseIf lin1="call" Then
		CurrentCallPoint:+1
		CallPoint[CurrentCallPoint]=i
		i=GotoLabel(lin2,i)
		Continue
	ElseIf lin1="ret" Then
		If CurrentCallPoint=-1 Then RuntimeError "DEBUG >> RET ohne CALL! LINE: "+i;Delay 1500;End
		i=CallPoint[CurrentCallPoint]
		CurrentCallPoint:-1
		Continue
	ElseIf lin1="int" Then
		If lin2="print" Then
			For vari=EachIn varlist
				If vari.name="cmd" Then Print vari.wert2
			Next
		ElseIf lin2="waitkey" Then
			For vari=EachIn varlist
				If vari.name="kbd" Then
					vari.wert1=WaitKey()
					Exit
				EndIf
			Next
		ElseIf lin2="input" Then
			If Left(Trim(lin3),1)=Chr(34) Then
				s=Input(Mid(Trim(lin3),2,Len(lin3)-3))
			ElseIf lin3<>"" Then 
				s=Input(RepVar(lin3))
			EndIf
			For vari=EachIn varlist
				If vari.name="cmd" Then vari.wert2=s
			Next
		ElseIf lin2="hitkey" Then
			For vari=EachIn varlist
				If vari.name="kbd" Then
					vari.wert1=GetKey(lin3)
					Exit
				EndIf
			Next
		ElseIf lin2="downkey" Then
			For vari=EachIn varlist
				If vari.name="kbd" Then
					vari.wert1=GetKey(lin3)
					Exit
				EndIf
			Next
		ElseIf lin2="delay" Then
			Delay(Int(lin3))
		EndIf
	ElseIf lin1="push" Then
		stack=New TStack
		stack.data=Replace(RepVar(lin2),Chr(34),"")
		stacklist.AddLast(stack)
	ElseIf lin1="pop" And stack<>Null Then
		If lin2<>"" Then
			For vari=EachIn varlist
				If vari.name=lin2 Then
					If vari.typ=1 Then
						vari.wert1=Int(stack.data)
					ElseIf vari.typ=2 Then
						vari.wert2=stack.data
					Else
						vari.wert3=Float(stack.data)
					EndIf
				EndIf
			Next
		Else
			For vari=EachIn varlist
				If vari.name="dx" Then vari.wert2=stack.data
			Next
		EndIf
		stacklist.remove(stack)
		stack=TStack(stacklist.Last())
	ElseIf lin1="end" Then
		End
	EndIf
Next
End

Function GotoLabel:Int(name$,i%)
	Local std%=i
	For i=0 To MAXLINES-1
		If line[i,0]=name$+":" Then Return i
	Next
	If name="main" Then Return std
	RuntimeError "DEBUG >> thasm kann das Label '"+name+"' nicht finden!"
	Return std
EndFunction

Type TStack
	Field data$
EndType


Type TVariable
	Field name$
	Field wert1%
	Field wert2$
	Field wert3#
	Field typ:Byte
EndType



Function RepVar$(txt$)
	For vari=EachIn varlist
		If vari.name=txt Then
			If vari.typ=1 Then
				txt=Replace(txt,vari.name,vari.wert1)
			ElseIf vari.typ=2 Then
				txt=Replace(txt,vari.name,vari.wert2)
			ElseIf vari.typ=3 Then
				txt=Replace(txt,vari.name,vari.wert3)
			EndIf
			Exit
		EndIf
	Next
	Return txt
EndFunction

Function ShRepVar$(txt$)
	If Not Instr(txt,"[") Then Return txt
	For vari=EachIn varlist
		If Instr(txt,"["+vari.name+"]") Then 
			If vari.typ=1 Then
				txt=Replace(txt,"["+vari.name+"]","["+String(vari.wert1)+"]")
			ElseIf vari.typ=3 Then
				txt=Replace(txt,"["+vari.name+"]","["+String(Int(vari.wert3))+"]")
			EndIf
		EndIf
	Next
	Return txt
EndFunction

Function GetKey:Byte(nr:String)
	If nr="LEFT" Then
		Return KeyDown(KEY_LEFT)
	ElseIf nr="RIGHT" Then
		Return KeyDown(KEY_RIGHT)
	ElseIf nr="UP" Then
		Return KeyDown(KEY_UP)
	ElseIf nr="DOWN" Then
		Return KeyDown(KEY_DOWN)
	ElseIf nr="ESC" Then
		Return KeyDown(KEY_ESCAPE)
	ElseIf nr="A" Then
		Return KeyDown(KEY_A)
	ElseIf nr="S" Then
		Return KeyDown(KEY_S)
	ElseIf nr="D" Then
		Return KeyDown(KEY_D)
	ElseIf nr="W" Then
		Return KeyDown(KEY_W)
	EndIf
EndFunction

Function GetCommandLine:String()
   Local clin$,cmd$
   For cmd = EachIn AppArgs[1..]
      clin:+ cmd +" "
   Next
   Return clin
End Function 

Function RepRuntimeConsts()
	lin2=Replace(lin2,"__TIMER__",MilliSecs())
	lin3=Replace(lin3,"__TIMER__",MilliSecs())
EndFunction

Function RepConsts()
	Local i%,j:Byte,k%
	For i=0 To MAXLINES-1
		For j=1 To 2
			Select line[i,j]
			Case "__LINE__"
				line[i,j]=String(i)
			Case "__WINDOWS__"
				?Win32
					line[i,j]="1"
				?Not Win32
					line[i,j]="0"
				?
			Case "__LINUX__"
				?Linux
					line[i,j]="1"
				?Not Linux
					line[i,j]="0"
				?
			Case "__MACOS__"
				?MacOS
					line[i,j]="1"
				?Not MacOS
					line[i,j]="0"
				?
			Case "__FUNC__"
				For k=i To 0 Step -1
					If Right(line[k,0],1)=":" Then
						line[i,j]=Left(line[k,0],Len(line[k,0])-1)
						Exit
					EndIf
				Next
			Case "__CTIMER__"
				line[i,j]=String(CompileTime)
			EndSelect
		Next
	Next
EndFunction
